<?php
/**
 * InlineResponse20146ContentContent
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineResponse20146ContentContent Class Doc Comment
 *
 * @category Class
 * @description ticket content of a tanss event
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineResponse20146ContentContent implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_response_201_46_content_content';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'ticket' => '\SLIS\Adapter\Tanss\Model\InlineResponse20146ContentContentTicket',
        'oldValues' => 'object',
        'comment' => '\SLIS\Adapter\Tanss\Model\InlineResponse20146ContentContentComment',
        'mail' => '\SLIS\Adapter\Tanss\Model\InlineResponse20146ContentContentMail',
        'support' => '\SLIS\Adapter\Tanss\Model\InlineResponse20146ContentContentSupport',
        'addedTags' => 'object[]',
        'removedTags' => 'object[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'ticket' => null,
        'oldValues' => null,
        'comment' => null,
        'mail' => null,
        'support' => null,
        'addedTags' => null,
        'removedTags' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'ticket' => 'ticket',
        'oldValues' => 'oldValues',
        'comment' => 'comment',
        'mail' => 'mail',
        'support' => 'support',
        'addedTags' => 'addedTags',
        'removedTags' => 'removedTags'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'ticket' => 'setTicket',
        'oldValues' => 'setOldValues',
        'comment' => 'setComment',
        'mail' => 'setMail',
        'support' => 'setSupport',
        'addedTags' => 'setAddedTags',
        'removedTags' => 'setRemovedTags'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'ticket' => 'getTicket',
        'oldValues' => 'getOldValues',
        'comment' => 'getComment',
        'mail' => 'getMail',
        'support' => 'getSupport',
        'addedTags' => 'getAddedTags',
        'removedTags' => 'getRemovedTags'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }


    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['ticket'] = $data['ticket'] ?? null;
        $this->container['oldValues'] = $data['oldValues'] ?? null;
        $this->container['comment'] = $data['comment'] ?? null;
        $this->container['mail'] = $data['mail'] ?? null;
        $this->container['support'] = $data['support'] ?? null;
        $this->container['addedTags'] = $data['addedTags'] ?? null;
        $this->container['removedTags'] = $data['removedTags'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets ticket
     *
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse20146ContentContentTicket|null
     */
    public function getTicket()
    {
        return $this->container['ticket'];
    }

    /**
     * Sets ticket
     *
     * @param \SLIS\Adapter\Tanss\Model\InlineResponse20146ContentContentTicket|null $ticket ticket
     *
     * @return self
     */
    public function setTicket($ticket)
    {
        $this->container['ticket'] = $ticket;

        return $this;
    }

    /**
     * Gets oldValues
     *
     * @return object|null
     */
    public function getOldValues()
    {
        return $this->container['oldValues'];
    }

    /**
     * Sets oldValues
     *
     * @param object|null $oldValues oldValues
     *
     * @return self
     */
    public function setOldValues($oldValues)
    {
        $this->container['oldValues'] = $oldValues;

        return $this;
    }

    /**
     * Gets comment
     *
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse20146ContentContentComment|null
     */
    public function getComment()
    {
        return $this->container['comment'];
    }

    /**
     * Sets comment
     *
     * @param \SLIS\Adapter\Tanss\Model\InlineResponse20146ContentContentComment|null $comment comment
     *
     * @return self
     */
    public function setComment($comment)
    {
        $this->container['comment'] = $comment;

        return $this;
    }

    /**
     * Gets mail
     *
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse20146ContentContentMail|null
     */
    public function getMail()
    {
        return $this->container['mail'];
    }

    /**
     * Sets mail
     *
     * @param \SLIS\Adapter\Tanss\Model\InlineResponse20146ContentContentMail|null $mail mail
     *
     * @return self
     */
    public function setMail($mail)
    {
        $this->container['mail'] = $mail;

        return $this;
    }

    /**
     * Gets support
     *
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse20146ContentContentSupport|null
     */
    public function getSupport()
    {
        return $this->container['support'];
    }

    /**
     * Sets support
     *
     * @param \SLIS\Adapter\Tanss\Model\InlineResponse20146ContentContentSupport|null $support support
     *
     * @return self
     */
    public function setSupport($support)
    {
        $this->container['support'] = $support;

        return $this;
    }

    /**
     * Gets addedTags
     *
     * @return object[]|null
     */
    public function getAddedTags()
    {
        return $this->container['addedTags'];
    }

    /**
     * Sets addedTags
     *
     * @param object[]|null $addedTags if tags were added, here the list of added tags is given
     *
     * @return self
     */
    public function setAddedTags($addedTags)
    {
        $this->container['addedTags'] = $addedTags;

        return $this;
    }

    /**
     * Gets removedTags
     *
     * @return object[]|null
     */
    public function getRemovedTags()
    {
        return $this->container['removedTags'];
    }

    /**
     * Sets removedTags
     *
     * @param object[]|null $removedTags if tags were removed, here the list of removed tags is given
     *
     * @return self
     */
    public function setRemovedTags($removedTags)
    {
        $this->container['removedTags'] = $removedTags;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


